/**
 *	_rtbl.c --  client side, for tbl_XX() functions
 *
 *		N.Kamikubota, June 14, 1992
 *
 * module structure:
 *	[ rtbllib ]     [client]               [server]     [ tbllib ]
 *	tbl_read() --+-- _rtbl()  <SC-SERVER>  _tbl() --+-- tbl_read()
 *	tbl_param() -+                                  +-- tbl_param()
 *	tbl_int() ---+                                  +-- tbl_int()
 *	tbl_node() --+                                  +-- tbl_node()
 * note:
 *  rtbllib and tbllib supplies same tbl_XX functions. 
 *  tbllib uses a local-host table, while rtbllib reads the remote-host tabel. 
 *  rtbllib requires a daemon (rtbld) in the remote-host. 
 *
 * not yet optimised for version 2
**/

/***********************************/
/* definitions  & global variables */
/***********************************/
#include	<stdio.h>
#include	"rtb2.h"	/* "tbl.h" included in "rtbl.h" */

/*** simulate tbl_XX() functions ***/
int	_tbl();
union sc_uarg	tblbuf;	/* paramater buffer */

/*******************************/
/**  main part of this module **/
/*******************************/

/* [1] tbl_read() */
int tbl_read( abbr )
char	*abbr;			/* abbr. name of the table */
{
	tbl_errno = _tbl( "READ", abbr );
	return tbl_errno;
}
/* [2] tbl_param() */
int tbl_param( name, param )
char	*name;			/* name to be searched */
int	*param;			/* parameters to be received */
{
	tbl_errno = _tbl( "PARAM", name, param );
	return tbl_errno;
}
/* [3] tbl_int() */
int tbl_int( name, key, data )
char	*name;			/* name to be searched */
char	*key;			/* parameter keyword */
int	*data;			/* integer parameter (return) */
{
	strncpy( tblbuf.cdim, key, L_KEY );
	tbl_errno = _tbl( "INT", name, &tblbuf );
	*data = tblbuf.iarg;
	return tbl_errno;
}
/* [4] tbl_node() */
char *tbl_node( name )
char	*name;			/* name to be searched */
{
	tbl_errno = _tbl( "NODE", name, &tblbuf );
	  if( strlen(tblbuf.cdim) <= 0 )	goto ENODE;
	return tblbuf.cdim;
ENODE:
	return NULL;
}
