/* This is dht.h --  Version 1.2
 * This code is copyright by
 *	Elmar Bartel 1993,
 *	Institut fuer Informatik, TU Muenchen, Germany  
 *	bartel@informatik.tu-muenchen.de
 * You may use this code as you wish, as long as this
 * comment with the above copyright notice is keept intact
 * and in place.
 */
/*
 * @(#)modified by k.furukawa, kek, v1.2.4 jul.1996-feb.1997
 */
typedef enum {
	dhtCopy, dhtNoCopy
} dhtValuePolicy;

/* Now finally this is the HashElement */
typedef struct {
	dhtValue	Key;
	dhtValue	Data;
} dhtElement;
#define dhtNilElement	(dhtElement *)0

struct dht;
#define dhtNilHashTable			(struct dht *)0


/* procedures */
struct dht *dhtCreate	
	(dhtValueType KeyType, dhtValuePolicy KeyPolicy,
	 dhtValueType DtaType, dhtValuePolicy DataPolicy);
dhtElement *dhtEnterElement
	(struct dht *, dhtValue key, dhtValue data);
void	      dhtDestroy	(struct dht *);
void	      dhtDump		(struct dht *, FILE *);
void	      dhtDumpIndented	(int i, struct dht *, FILE *);
void	      dhtRemoveElement	(struct dht *, dhtValue key);
dhtElement   *dhtLookupElement	(struct dht *, dhtValue key);
dhtElement   *dhtGetFirstElement(struct dht *);
dhtElement   *dhtGetNextElement	(struct dht *);
unsigned long dhtActualLoad	(struct dht *);
unsigned long dhtKeyCount	(struct dht *);

#define HashTable		struct dht
#define NilHashTable		dhtNilHashTable
#define NilHashElement		dhtNilElement
#define	CreateHashTable		dhtCreate
#define DestroyHashTable	dhtDestroy
#define EnterHashElement	dhtEnterElement
#define RemoveHashElement	dhtRemoveElement
#define LookupHashElement	dhtLookupElement
#define GetFirstHashElement	dhtGetFirstElement
#define GetNextHashElement	dhtGetNextElement
#define	fDumpHashTable		dhtDump
