/**
 *	tbl_node.c	n.k.	june 9, 1992
 *	tb2_node.c	k.f.	july 29, 1996
 *
 *  char *tb2_node( tb2_Spec *tb2, char* name )  
 *         -  get pointer of node for specified name
 *     tb2 - table spec returned from tb2_read()
 *    name - name to be searched (in the first row, KEY="NAME")
 *
 *  char *tbl_node( char* name )  
 *         -  get pointer of node for specified name
 *    name - name to be searched (in the first row, KEY="NAME")
 *
 *  return:  pointer to node (char*) for specified name and keyword
 *  tb2_errno: n=0  -- successfully completed
 *             < 0  -- error (see tbl.h)
 * 
 * Modifications:
**/
static char what_tb2node[] =
"@(#)tb2_node.c, v2.0.2, n.f, k.f, table name-to-node, jun.1992-oct.1996";

/*** definitions ***/
#include  "tb2.h"         /* error codes, default directory */

/**
 *   tb2_node() - get node for name and keyword
**/
char *tb2_node( tb2, name )
tb2_Spec *tb2;		/* table specification */
char  *name;		/* name to be searched */
{
    tb2_ParamEnt * parament;		/* table parameter list */

    if ( !(tb2) )  goto EUNREAD;	/* invalid table */

    if ( strcmp( (*(tb2->tb2_paramkey))[1].keyword, "NODE" ) )  goto ENODE;

    if ( !(parament = tb2_data( tb2, name, "NODE" )) )  goto ENAME;

    return ( parament->string );

/*** errors ***/
 EUNREAD:
#ifdef TBL_WARN
    fprintf( WARN_DEST, "tb2_name %s: table is not read yet\n", TBL_VER );
#endif
    tb2_errno = TBL_E_UNREAD;
    return (char *)NULL;

 ENODE:
#ifdef TBL_WARN
    fprintf( WARN_DEST, "tb2_node %s: key=NODE not in the table='%s'\n", 
	    TBL_VER, tb2->filename );
#endif
    tb2_errno = TBL_E_NONODE;
    return (char *)NULL;

 ENAME:
#ifdef TBL_WARN
    fprintf( WARN_DEST, "tbl_name %s: name '%s' not found in table '%s'\n",
	    TBL_VER, name, tb2->filename );
#endif
    tb2_errno = TBL_E_NONAME;
    return (char *)NULL;
}

/**
 *   tbl_node() - get node for name and keyword
**/
char *tbl_node( name )
char  *name;			/* name to be searched */
{
    return tb2_node( default_tbl, name );
}
